<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<?php 
	/* 
	 * deltaStar Online v1.0 
	 * Search Washington Double Star Catalog (WDS) data by coordinates, separation, and magnitude criteria.
	 * This catalog is maintained by the United States Naval Observatory http://ad.usno.navy.mil/wds/wds.html.
	 *
	 * Created by Rick Burton - Data Pathways 01/28/2013
	 * rick.burton@datapathways.com http://astronomy.datapathways.com
	 */

	// Retrieve date of last data update from date.txt file
	// This file is generated by the getwdsfile.sh script
	global $updated;
	$updated = @file('date.txt');
?>

<head>
	<title>&Delta;* deltaStar Online [WDS Catalog Search]</title>
	<meta http-equiv="Content-type" content="text/html;charset=UTF-8" />
	<script type="text/javascript">

		// Check for minimum search parm (RA hours) and submit form
		function searchCatalog()
		{
			if(document.searchfrm.ra_hours.value == "")
			{
				alert("Select R.A. Hours - other choices optional");
				return;
			}
			document.searchfrm.submit();
		}

		// Set all controls at load to initial values
		// If the form has been submitted, values are retained
		function setParms()
		{
			document.searchfrm.ra_hours.value         = "<?php print $_REQUEST['ra_hours']; ?>";
			document.searchfrm.ra_hours.value         = "<?php print (isset($_REQUEST['ra_hours']) ? $_REQUEST['ra_hours'] : '00'); ?>";
			document.searchfrm.ra_minutes_tens.value  = "<?php print $_REQUEST['ra_minutes_tens']; ?>";
			document.searchfrm.ra_minutes_ones.value  = "<?php print $_REQUEST['ra_minutes_ones']; ?>";
			document.searchfrm.dec_sign.value         = "<?php print (isset($_REQUEST['dec_sign']) ? $_REQUEST['dec_sign'] : '+'); ?>";
			document.searchfrm.dec_degrees_tens.value = "<?php print $_REQUEST['dec_degrees_tens']; ?>";
			document.searchfrm.dec_degrees_ones.value = "<?php print $_REQUEST['dec_degrees_ones']; ?>";
			document.searchfrm.sep_seconds_min.value  = "<?php print $_REQUEST['sep_seconds_min']; ?>";
			document.searchfrm.primary_mag_min.value  = "<?php print $_REQUEST['primary_mag_min']; ?>";
		}

		// Currently unused
		function resetPage()
		{
			window.location = "search.php";
		}

		// When selecting Declination ones, set tens to 0 IF tens unselected
		function checkDecDegTens()
		{
			if(document.searchfrm.dec_degrees_tens.value == "")
				document.searchfrm.dec_degrees_tens.value = "0";
		}

		// When selecting RA Minutes ones, set tens to 0 IF tens unselected
		function checkRAMinTens()
		{
			if(document.searchfrm.ra_minutes_tens.value == "")
				document.searchfrm.ra_minutes_tens.value = "0";
		}

		// when selecting Declination tens, set 1s to unselected IF tens unselected
		function checkDecDegOnes()
		{
			if(document.searchfrm.dec_degrees_tens.value == "")
				document.searchfrm.dec_degrees_ones.value = "";
		}

		// when selecting RA Minutes tens, set ones to unselected IF tens unselected
		function checkRAMinOnes()
		{
			if(document.searchfrm.ra_minutes_tens.value == "")
				document.searchfrm.ra_minutes_ones.value = "";
		}

	</script>
	<style type="text/css">
		/* General page-wide element style section */
		BODY
		{
			font-family: 'Courier Regular', 'Courier New', 'Courier 10 Pitch', monospace;
			font-weight: bold;
			color: #0f0;
			background: #002;
		}
		A
		{
			font-family: 'Courier Regular', 'Courier New', 'Courier 10 Pitch', monospace;
			font-weight: bold;
			color: #06f;
			background: transparent;
			text-decoration: none;
		}
		A:hover
		{
			color: #fff;
			background: #69c;
			text-decoration: none;
		}
		SELECT
		{
			margin: 0px;
			padding: 0px;
			font-size: 11px;
			line-height: 13px;			
		}
		OPTION
		{
			margin: 0px;
			padding: 0px;
			font-size: 11px;
			line-height: 13px;			
		}
		BUTTON
		{
			font-size: 11px;
			line-height: 13px;
		}

		/* Main Content Container */
		DIV.container
		{
			margin-left:auto; margin-right:auto; 
			width:980px; position:relative;
		}

		/* Title Section */
		DIV.title
		{
			color:#eee; background:transparent; 
			font-family:sans-serif; font-weight:bold; 
			font-size:24px; line-height:24px;
			position:absolute;
			top:6px; left:7px;
		}
		DIV.title2 /* drop shadow */
		{
			color:#33e; background:transparent; 
			font-family:sans-serif; font-weight:bold; 
			font-size:24px; line-height:24px;
			position:absolute;
			top:4px; left:4px;
			z-index:-1;
		}

		/* Virtual Monitor Section */
		DIV.searchCtrl, DIV.search
		{
			font-size: 11px;
			line-height: 13px;
		}
		DIV.searchCtrl /* Upper section of monitor containing controls */
		{
			border-left:6px solid gray; border-top:6px solid gray; 
			border-right:6px solid silver; /*border-bottom:6px solid silver; */
			padding:8px 8px 0px 8px; width:950px; height:188px;
			position:absolute; top:40px;
			color:#0f0; background:#000;
		}
		DIV.search /* Lower section of monitor containing search results */
		{
			border-left:6px solid gray;
			border-right:6px solid silver; border-bottom:6px solid silver; 
			padding:0px 8px 8px 8px; width:950px;
			position:absolute; margin-top:242px;
			color:#0f0; background:#000;
			height:384px; overflow:auto;
		}

	</style>
	<link rel="shortcut icon" type="image/ico" href="/OtherWorld.ico"/>
</head> 

<body class="search" onload="setParms(); printNum();">
<div class="container">

	<!-- Drop shadow title -->
	<div class="title">
		<font>&nbsp;Rick's Astronomy - &Delta;* - deltaStar [WDS Double Star Search]&nbsp;</font>
	</div>
	<div class="title2">
		<font>&nbsp;Rick's Astronomy - &Delta;* - deltaStar [WDS Double Star Search]&nbsp;</font>
	</div>

	<div class="searchCtrl">

	<!-- MENU Section - not wrapped to avoid extra padding between items in rendering -->
	<a href="/index.php">&nbsp;Home&nbsp;</a>|<a href="/astroblog.php">&nbsp;Astro Blog&nbsp;</a>|<a href="/astrogallery.php">&nbsp;Astro Gallery&nbsp;</a>|<a href="/vstar.php">&nbsp;vStar Download&nbsp;</a>|<a href="/concepts/AAVSO/search.php">&nbsp;Variable Star Search&nbsp;</a>|<a href="Users_Guide.html" target="_blank">&nbsp;HELP&nbsp;</a>
	<br/><br/>
	<form name="searchfrm" method="post" action="search.php">
		<!-- R.A. Hour -->
		<select name="ra_hours">
			<!-- <option value=""></option> -->
			<option value="00">00</option>
			<option value="01">01</option>
			<option value="02">02</option>
			<option value="03">03</option>
			<option value="04">04</option>
			<option value="05">05</option>
			<option value="06">06</option>
			<option value="07">07</option>
			<option value="08">08</option>
			<option value="09">09</option>
			<option value="10">10</option>
			<option value="11">11</option>
			<option value="12">12</option>
			<option value="13">13</option>
			<option value="14">14</option>
			<option value="15">15</option>
			<option value="16">16</option>
			<option value="17">17</option>
			<option value="18">18</option>
			<option value="19">19</option>
			<option value="20">20</option>
			<option value="21">21</option>
			<option value="22">22</option>
			<option value="23">23</option>
		</select> Hour
		<!-- R.A. 10s of Minutes -->
		<select name="ra_minutes_tens" onchange="checkRAMinOnes();">
			<option value="">---</option>
			<option value="0">00</option>
			<option value="1">10</option>
			<option value="2">20</option>
			<option value="3">30</option>
			<option value="4">40</option>
			<option value="5">50</option>
			<option value="6">60</option>
			<option value="7">70</option>
			<option value="8">80</option>
			<option value="9">90</option>
		</select> 10s
		<!-- R.A. Minute -->
		<select name="ra_minutes_ones" onchange="checkRAMinTens();">
			<option value="">--</option>
			<option value="0">0</option>
			<option value="1">1</option>
			<option value="2">2</option>
			<option value="3">3</option>
			<option value="4">4</option>
			<option value="5">5</option>
			<option value="6">6</option>
			<option value="7">7</option>
			<option value="8">8</option>
			<option value="9">9</option>
		</select> 1s Minutes - Right Ascension
		<br/>
		<!-- Declination N/S Sign (+/-) -->
		<select name="dec_sign">
			<option value="+">North</option>
			<option value="-">South</option>
		</select> 
		<!-- Declination 10s of Degrees -->
		<select name="dec_degrees_tens" onchange="checkDecDegOnes();">
			<option value="">---</option>
			<option value="0">00</option>
			<option value="1">10</option>
			<option value="2">20</option>
			<option value="3">30</option>
			<option value="4">40</option>
			<option value="5">50</option>
			<option value="6">60</option>
			<option value="7">70</option>
			<option value="8">80</option>
			<option value="9">90</option>
		</select> 10s
		<!-- Declination Degrees -->
		<select name="dec_degrees_ones" onchange="checkDecDegTens();">
			<option value="">--</option>
			<option value="0">0</option>
			<option value="1">1</option>
			<option value="2">2</option>
			<option value="3">3</option>
			<option value="4">4</option>
			<option value="5">5</option>
			<option value="6">6</option>
			<option value="7">7</option>
			<option value="8">8</option>
			<option value="9">9</option>
		</select> 1s - Degrees Declination
		<br/>
		<!-- Minumum Separation in arc seconds -->
		<select name="sep_seconds_min">
			<option value="">--</option>
			<option value="1">1</option>
			<option value="2">2</option>
			<option value="3">3</option>
			<option value="4">4</option>
			<option value="5">5</option>
			<option value="6">6</option>
			<option value="7">7</option>
			<option value="8">8</option>
			<option value="9">9</option>
			<option value="10">10</option>
			<option value="20">20</option>
			<option value="30">30</option>
			<option value="40">40</option>
			<option value="50">50</option>
			<option value="60">60</option>
			<option value="120">120</option>
			<option value="180">180</option>
			<option value="240">240</option>
			<option value="300">300</option>
		</select> Minimum Sep Arc Secs  
		<!--Minumum Magnitude of primary star  -->
		<select name="primary_mag_min">
			<option value="">---</option>
			<option value="19">19</option>
			<option value="18">18</option>
			<option value="17">17</option>
			<option value="16">16</option>
			<option value="15">15</option>
			<option value="14">14</option>
			<option value="13">13</option>
			<option value="12">12</option>
			<option value="11">11</option>
			<option value="10">10</option>
			<option value="9">9</option>
			<option value="8">8</option>
			<option value="7">7</option>
			<option value="6">6</option>
			<option value="5">5</option>
			<option value="4">4</option>
			<option value="3">3</option>
			<option value="2">2</option>
		</select> Minimum Primary Magnitude<br/>
		<input type="hidden" name="form_action" value="search"/><br/>
	</form>
	<button name="searchbtn" onclick="searchCatalog();">Search</button>
	<button name="resetbtn" onclick="document.searchfrm.reset();document.searchfrm.form_action.value='';window.location='search.php';">Reset</button>
	<button name="helpbtn" onclick="window.open('Users_Guide.html');">HELP</button>&nbsp;
	<font color="red">Data Last Updated</font> <?php print $updated[0]; ?>

<?php
	main();
	// Used similar to C style main()
	function main()
	{
		global $output; // Contains formatted records
		global $curr;   // Array for output formatting - current characters 
		global $repl;   // Array for output formatting - replacement strings
		global $num_results; // Counter for number of records matching search criteria
	
		// Set variables' values
		$output = '';
		$curr = array(" ", "\n", "\t");
		$repl = array("&nbsp;", "<br/> ", "&nbsp;&nbsp;&nbsp;&nbsp;");
		$num_results = 0;
		$search = isset($_REQUEST['form_action']) && $_REQUEST['form_action'] === 'search';

		$header = '
    WDS    Discovr Comp  EPOCH      #  THETA       RHO     Magnitudes Spectral  Prop Mot  2nd PM   DM Desig Note     Precise       
Identifier              Frst Last      Fst Lst First  Last  Pri   Sec  Type      RA" DEC" RA" DEC"                 Coordinate      
___________________________________________________________________________________________________________________________________

	';
		if($search)
			print '<font color="red"><span id="num_results">Searching...</span></font>
			';

		print '<br/>';
		print str_replace($curr, $repl, $header);
		print '</div>';
		print '<div class="search">';

		if($search)
		{	
			$handle = @fopen("wdsweb_summ.txt", "r");
			if ($handle) 
			{
				while (($buffer = fgets($handle, 4096)) !== false) 
				{
					$print = false;
					// RA hour Search parameter
					// ----------------------------------------------------------------------------------------------------------
					if(substr($buffer, 0, 2) === $_REQUEST['ra_hours'])
					{
						$print = true;

						// RA minutes Search parameters
						// --------------------------------------------------------------------------------------------------
						if($print && $_REQUEST['ra_minutes_tens'] !== '')
							$print = substr($buffer, 2, 1) === $_REQUEST['ra_minutes_tens'];
						if($print && $_REQUEST['ra_minutes_ones'] !== '')
							$print = substr($buffer, 3, 1) === $_REQUEST['ra_minutes_ones'];

						// Declination Search parameters
						// --------------------------------------------------------------------------------------------------
						if($print && $_REQUEST['dec_degrees_tens'] !== '')
							$print = substr($buffer, 5, 2) === ($_REQUEST['dec_sign'].$_REQUEST['dec_degrees_tens']);
						if($print && $_REQUEST['dec_degrees_ones'] !== "")
							$print = substr($buffer, 7, 1) === $_REQUEST['dec_degrees_ones'];

						// Star system configuration Search parameters
						// --------------------------------------------------------------------------------------------------
						if($print && $_REQUEST['sep_seconds_min'] !== '')
							$print = (double)substr($buffer, 52, 5) >= (double)$_REQUEST['sep_seconds_min'];
						if($print && $_REQUEST['primary_mag_min'] !== '')
							$print = (double)substr($buffer, 58, 5) <= (double)$_REQUEST['primary_mag_min'];
					}

					if($print)
					{
						$output = str_replace($curr, $repl, $buffer);
						print '<font color="white">'.substr($output, 0, 10).'</font>&nbsp;'.substr($output, 10, -1);
						$num_results++;
					}
				}

				if (!feof($handle)) 
				{
					echo "Error: unexpected fgets() fail\n";
				}
		
				fclose($handle);
			}
		}
		print '<font style="font-weight:bold; text-decoration:blink;">_</font>';
	}

?>
	<script type="text/javascript">
		function printNum() 
		{ 
			document.getElementById("num_results").innerHTML = "Records Found: <?php print $num_results; ?>"; 
		}
	</script>

	</div>
</div>
</body>
</html>


